blob: be0a88d1f92fc3a58a9aee5df7998b4f3fc1f3b0 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Colin Crosse0ef0a82017-07-27 21:29:18 +000049export USE_JACK="false"
Igor Murashkin2a337752017-06-16 14:34:40 +000050export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070051export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070052
Alan Leungd5cbc562018-03-15 14:02:46 -070053# If d8 was not set by the environment variable, assume it is in the path.
54if [ -z "$D8" ]; then
55 export D8="d8"
56fi
57
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070058# If dx was not set by the environment variable, assume it is in the path.
59if [ -z "$DX" ]; then
60 export DX="dx"
61fi
62
Alan Leungd5cbc562018-03-15 14:02:46 -070063export DXMERGER="$D8"
64
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080065# If jasmin was not set by the environment variable, assume it is in the path.
66if [ -z "$JASMIN" ]; then
67 export JASMIN="jasmin"
68fi
69
Andreas Gampe8fda9f22014-10-03 16:15:37 -070070# If smali was not set by the environment variable, assume it is in the path.
71if [ -z "$SMALI" ]; then
72 export SMALI="smali"
73fi
74
Sebastien Hertz19ac0272015-02-24 17:39:50 +010075# If jack was not set by the environment variable, assume it is in the path.
76if [ -z "$JACK" ]; then
77 export JACK="jack"
78fi
79
Sebastien Hertz19ac0272015-02-24 17:39:50 +010080# ANDROID_BUILD_TOP is not set in a build environment.
81if [ -z "$ANDROID_BUILD_TOP" ]; then
82 export ANDROID_BUILD_TOP=$oldwd
83fi
84
Andreas Gampef47fb2f2016-06-24 22:30:29 -070085# ANDROID_HOST_OUT is not set in a build environment.
86if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080087 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088fi
89
Sebastien Hertz19ac0272015-02-24 17:39:50 +010090# If JACK_CLASSPATH is not set, assume it only contains core-libart.
91if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070092 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010093fi
94
Sebastien Hertz19ac0272015-02-24 17:39:50 +010095export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080096
Igor Murashkine5181932017-06-15 16:03:50 -070097# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070098if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070099 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
100fi
101
Igor Murashkin271a0f82017-02-14 21:14:17 +0000102# Zipalign is not on the PATH in some configs, auto-detect it.
103if [ -z "$ZIPALIGN" ]; then
104 if which zipalign >/dev/null; then
105 ZIPALIGN="zipalign";
106 else
107 # TODO: Add a dependency for zipalign in Android.run-test.mk
108 # once it doesn't depend on libandroidfw (b/35246701)
109 case "$OSTYPE" in
110 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
111 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
112 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
113 esac
114 fi
115fi
116export ZIPALIGN
117
David Brazdil122c6632018-01-24 17:32:49 +0000118# If hiddenapi was not set by the environment variable, assume it is in
119# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000120if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000121 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000122fi
123
Roland Levillain76cfe612017-10-30 13:14:28 +0000124chroot=
125
jeffhao5d1ac922011-09-29 17:41:15 -0700126info="info.txt"
127build="build"
128run="run"
129expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700130check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700131output="output.txt"
132build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100133cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700134strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700135lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700136testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700137run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000138build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700139
Alex Light91de25f2015-10-28 17:00:06 -0700140quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000141debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700142prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700143target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700144dev_mode="no"
145update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700146debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000147relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800148runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700149usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700150build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700151suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700152trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700153trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700154basic_verify="false"
155gc_verify="false"
156gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700157jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700158jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700159jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700160jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700161strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700162always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700163never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700164have_dex2oat="yes"
165have_patchoat="yes"
166have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800167multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000168android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700169bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800170suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700171# By default we will use optimizing.
172image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000173image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700174
175while true; do
176 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700177 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700178 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100179 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700180 shift
Alex Light91de25f2015-10-28 17:00:06 -0700181 elif [ "x$1" = "x--quiet" ]; then
182 quiet="yes"
183 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700184 elif [ "x$1" = "x--use-java-home" ]; then
185 if [ -n "${JAVA_HOME}" ]; then
186 export JAVA="${JAVA_HOME}/bin/java"
187 export JAVAC="${JAVA_HOME}/bin/javac -g"
188 else
189 echo "Passed --use-java-home without JAVA_HOME variable set!"
190 usage="yes"
191 fi
192 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800193 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700194 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800195 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800196 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700197 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700198 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700199 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100200 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100201 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700202 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800203 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700204 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700205 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700206 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700207 shift
208 elif [ "x$1" = "x--dalvik" ]; then
209 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800210 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700211 shift
Alex Light03a112d2014-08-25 13:25:56 -0700212 elif [ "x$1" = "x--no-dex2oat" ]; then
213 have_dex2oat="no"
214 shift
215 elif [ "x$1" = "x--no-patchoat" ]; then
216 have_patchoat="no"
217 shift
218 elif [ "x$1" = "x--no-image" ]; then
219 have_image="no"
220 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800221 elif [ "x$1" = "x--multi-image" ]; then
222 multi_image_suffix="-multi"
223 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700224 elif [ "x$1" = "x--pic-test" ]; then
225 run_args="${run_args} --pic-test"
226 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700227 elif [ "x$1" = "x--relocate" ]; then
228 relocate="yes"
229 shift
230 elif [ "x$1" = "x--no-relocate" ]; then
231 relocate="no"
232 shift
233 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100234 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700235 prebuild_mode="yes"
236 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800237 elif [ "x$1" = "x--compact-dex-level" ]; then
238 option="$1"
239 shift
240 run_args="${run_args} $option $1"
241 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700242 elif [ "x$1" = "x--strip-dex" ]; then
243 run_args="${run_args} --strip-dex"
244 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000245 elif [ "x$1" = "x--debuggable" ]; then
246 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000247 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000248 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700249 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100250 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700251 prebuild_mode="no"
252 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700253 elif [ "x$1" = "x--gcverify" ]; then
254 basic_verify="true"
255 gc_verify="true"
256 shift
257 elif [ "x$1" = "x--gcstress" ]; then
258 basic_verify="true"
259 gc_stress="true"
260 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700261 elif [ "x$1" = "x--jvmti-step-stress" ]; then
262 jvmti_step_stress="true"
263 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700264 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
265 jvmti_redefine_stress="true"
266 shift
Alex Light43e935d2017-06-19 15:40:40 -0700267 elif [ "x$1" = "x--jvmti-field-stress" ]; then
268 jvmti_field_stress="true"
269 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700270 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
271 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700272 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800273 elif [ "x$1" = "x--suspend-timeout" ]; then
274 shift
275 suspend_timeout="$1"
276 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700277 elif [ "x$1" = "x--image" ]; then
278 shift
279 image="$1"
280 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700281 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000282 elif [ "x$1" = "x-Xcompiler-option" ]; then
283 shift
284 option="$1"
285 run_args="${run_args} -Xcompiler-option $option"
286 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000287 elif [ "x$1" = "x--build-option" ]; then
288 shift
289 option="$1"
290 build_args="${build_args} $option"
291 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700292 elif [ "x$1" = "x--runtime-option" ]; then
293 shift
294 option="$1"
295 run_args="${run_args} --runtime-option $option"
296 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700297 elif [ "x$1" = "x--gdb-arg" ]; then
298 shift
299 gdb_arg="$1"
300 run_args="${run_args} --gdb-arg $gdb_arg"
301 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700302 elif [ "x$1" = "x--debug" ]; then
303 run_args="${run_args} --debug"
304 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700305 elif [ "x$1" = "x--debug-wrap-agent" ]; then
306 run_args="${run_args} --debug-wrap-agent"
307 shift
Alex Light0e151e72017-10-25 10:50:35 -0700308 elif [ "x$1" = "x--with-agent" ]; then
309 shift
310 option="$1"
311 run_args="${run_args} --with-agent $1"
312 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700313 elif [ "x$1" = "x--debug-agent" ]; then
314 shift
315 option="$1"
316 run_args="${run_args} --debug-agent $1"
317 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700318 elif [ "x$1" = "x--gdb" ]; then
319 run_args="${run_args} --gdb"
320 dev_mode="yes"
321 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700322 elif [ "x$1" = "x--strace" ]; then
323 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700324 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700325 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700326 elif [ "x$1" = "x--zygote" ]; then
327 run_args="${run_args} --zygote"
328 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800329 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000330 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700331 image_suffix="-interpreter"
332 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800333 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700334 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000335 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800336 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700337 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700338 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800339 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700340 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700341 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700342 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700343 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700344 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700345 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700346 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700347 elif [ "x$1" = "x--no-optimize" ]; then
348 run_args="${run_args} --no-optimize"
349 shift
350 elif [ "x$1" = "x--no-precise" ]; then
351 run_args="${run_args} --no-precise"
352 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700353 elif [ "x$1" = "x--invoke-with" ]; then
354 shift
355 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700356 if [ "x$what" = "x" ]; then
357 echo "$0 missing argument to --invoke-with" 1>&2
358 usage="yes"
359 break
360 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700361 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700362 shift
363 elif [ "x$1" = "x--dev" ]; then
364 run_args="${run_args} --dev"
365 dev_mode="yes"
366 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700367 elif [ "x$1" = "x--build-only" ]; then
368 build_only="yes"
369 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100370 elif [ "x$1" = "x--build-with-javac-dx" ]; then
371 USE_JACK="false"
372 shift
373 elif [ "x$1" = "x--build-with-jack" ]; then
374 USE_JACK="true"
375 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700376 elif [ "x$1" = "x--output-path" ]; then
377 shift
378 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700379 if [ "x$tmp_dir" = "x" ]; then
380 echo "$0 missing argument to --output-path" 1>&2
381 usage="yes"
382 break
383 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700384 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000385 elif [ "x$1" = "x--chroot" ]; then
386 shift
387 if [ "x$1" = "x" ]; then
388 echo "$0 missing argument to --chroot" 1>&2
389 usage="yes"
390 break
391 fi
392 chroot="$1"
393 run_args="${run_args} --chroot $1"
394 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000395 elif [ "x$1" = "x--android-root" ]; then
396 shift
397 if [ "x$1" = "x" ]; then
398 echo "$0 missing argument to --android-root" 1>&2
399 usage="yes"
400 break
401 fi
402 android_root="$1"
403 run_args="${run_args} --android-root $1"
404 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700405 elif [ "x$1" = "x--update" ]; then
406 update_mode="yes"
407 shift
408 elif [ "x$1" = "x--help" ]; then
409 usage="yes"
410 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700411 elif [ "x$1" = "x--64" ]; then
412 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700413 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700414 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200415 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700416 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200417 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700418 elif [ "x$1" = "x--stream" ]; then
419 trace_stream="true"
420 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700421 elif [ "x$1" = "x--always-clean" ]; then
422 always_clean="yes"
423 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700424 elif [ "x$1" = "x--never-clean" ]; then
425 never_clean="yes"
426 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800427 elif [ "x$1" = "x--dex2oat-swap" ]; then
428 run_args="${run_args} --dex2oat-swap"
429 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700430 elif [ "x$1" = "x--instruction-set-features" ]; then
431 shift
432 run_args="${run_args} --instruction-set-features $1"
433 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700434 elif [ "x$1" = "x--bisection-search" ]; then
435 bisection_search="yes"
436 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000437 elif [ "x$1" = "x--vdex" ]; then
438 run_args="${run_args} --vdex"
439 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000440 elif [ "x$1" = "x--dm" ]; then
441 run_args="${run_args} --dm"
442 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000443 elif [ "x$1" = "x--vdex-filter" ]; then
444 shift
445 filter=$1
446 run_args="${run_args} --vdex-filter $filter"
447 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700448 elif [ "x$1" = "x--random-profile" ]; then
449 run_args="${run_args} --random-profile"
450 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700451 elif [ "x$1" = "x--dex2oat-jobs" ]; then
452 shift
453 run_args="${run_args} -Xcompiler-option -j$1"
454 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700455 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700456 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700457 usage="yes"
458 break
459 else
460 break
461 fi
462done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700463
Roland Levillain76cfe612017-10-30 13:14:28 +0000464# The DEX_LOCATION with the chroot prefix, if any.
465chroot_dex_location="$chroot$DEX_LOCATION"
466
Alex Light10bc5a42016-05-10 10:01:22 -0700467run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700468# Allocate file descriptor real_stderr and redirect it to the shell's error
469# output (fd 2).
470if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
471 exec {real_stderr}>&2
472else
473 # In bash before version 4.1 we need to do a manual search for free file
474 # descriptors.
475 FD=3
476 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
477 real_stderr=$FD
478 eval "exec ${real_stderr}>&2"
479fi
480if [ "$quiet" = "yes" ]; then
481 # Force the default standard output and error to go to /dev/null so we will
482 # not print them.
483 exec 1>/dev/null
484 exec 2>/dev/null
485fi
486
487function err_echo() {
488 echo "$@" 1>&${real_stderr}
489}
490
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700491# tmp_dir may be relative, resolve.
492#
493# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000494# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700495# Cannot use readlink -m, as it does not exist on Mac.
496# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700497noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700498tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700499mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700500
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800501# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000502if [ ! "$runtime" = "jvm" ]; then
503 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
504fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800505
Alex Lighte7873ec2014-08-12 09:53:50 -0700506if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800507 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
508 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700509fi
510if [ "$gc_verify" = "true" ]; then
511 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
512fi
513if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700514 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700515fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700516if [ "$jvmti_redefine_stress" = "true" ]; then
517 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
518fi
Alex Lightc38c3692017-06-27 15:45:14 -0700519if [ "$jvmti_step_stress" = "true" ]; then
520 run_args="${run_args} --no-app-image --jvmti-step-stress"
521fi
Alex Light43e935d2017-06-19 15:40:40 -0700522if [ "$jvmti_field_stress" = "true" ]; then
523 run_args="${run_args} --no-app-image --jvmti-field-stress"
524fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700525if [ "$jvmti_trace_stress" = "true" ]; then
526 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700527fi
Jeff Hao85139a32014-07-23 11:52:52 -0700528if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700529 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
530 if [ "$trace_stream" = "true" ]; then
531 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
532 # the ability to analyze the file and just write to /dev/null.
533 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
534 # Enable streaming mode.
535 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
536 else
537 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
538 fi
539elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700540 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700541 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700542fi
543
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700544# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000545# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100546function guess_target_arch_name() {
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000547 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
548 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700549 if [ "x${suffix64}" = "x64" ]; then
550 target_arch_name=${grep64bit}
551 else
552 target_arch_name=${grep32bit}
553 fi
554}
555
David Brazdil853a4c32015-09-28 16:15:50 +0100556function guess_host_arch_name() {
557 if [ "x${suffix64}" = "x64" ]; then
558 host_arch_name="x86_64"
559 else
560 host_arch_name="x86"
561 fi
562}
563
Alex Lighta59dd802014-07-02 16:28:08 -0700564if [ "$target_mode" = "no" ]; then
565 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700566 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700567 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000568 exit 1
569 fi
570 else
571 # ART/Dalvik host mode.
572 if [ -n "$chroot" ]; then
573 err_echo "--chroot with --host is unsupported"
574 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700575 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700576 fi
577fi
578
Alex Light03a112d2014-08-25 13:25:56 -0700579if [ "$have_patchoat" = "no" ]; then
580 run_args="${run_args} --no-patchoat"
581fi
582
583if [ "$have_dex2oat" = "no" ]; then
584 run_args="${run_args} --no-dex2oat"
585fi
586
Jeff Hao201803f2013-11-20 18:11:39 -0800587if [ ! "$runtime" = "jvm" ]; then
588 run_args="${run_args} --lib $lib"
589fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700590
Jeff Hao201803f2013-11-20 18:11:39 -0800591if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700592 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000593 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800594 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700595 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700596 else
597 true # defaults to using target BOOTCLASSPATH
598 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800599elif [ "$runtime" = "art" ]; then
600 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100601 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000602 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700603 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800604 else
David Brazdil853a4c32015-09-28 16:15:50 +0100605 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800606 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000607 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800608 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700609 if [ "$relocate" = "yes" ]; then
610 run_args="${run_args} --relocate"
611 else
612 run_args="${run_args} --no-relocate"
613 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700614elif [ "$runtime" = "jvm" ]; then
615 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800616 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700617fi
618
Alex Light03a112d2014-08-25 13:25:56 -0700619if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700620 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700621 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700622 exit 1
623 fi
Alex Light03a112d2014-08-25 13:25:56 -0700624 run_args="${run_args} --no-image"
625fi
626
jeffhao5d1ac922011-09-29 17:41:15 -0700627if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700628 err_echo "--dev and --update are mutually exclusive"
629 usage="yes"
630fi
631
632if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
633 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700634 usage="yes"
635fi
636
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700637if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
638 err_echo "--bisection-search and --prebuild are mutually exclusive"
639 usage="yes"
640fi
641
642if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
643 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
644 usage="yes"
645fi
646
647if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
648 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
649 usage="yes"
650fi
651
Roland Levillain76cfe612017-10-30 13:14:28 +0000652# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
653if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
654 err_echo "--chroot with --bisection-search is unsupported"
655 exit 1
656fi
657
jeffhao5d1ac922011-09-29 17:41:15 -0700658if [ "$usage" = "no" ]; then
659 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
660 test_dir=`basename "$oldwd"`
661 else
662 test_dir="$1"
663 fi
664
665 if [ '!' -d "$test_dir" ]; then
666 td2=`echo ${test_dir}-*`
667 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700668 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700669 usage="yes"
670 fi
671 test_dir="$td2"
672 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700673 # Shift to get rid of the test name argument. The rest of the arguments
674 # will get passed to the test run.
675 shift
676fi
677
Søren Gjesse620d0a52016-09-19 11:12:51 +0200678# For building with javac and dx always use Java 7. The dx compiler
679# only support byte codes from Java 7 or earlier (class file major
680# version 51 or lower).
681if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
682 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
683fi
684
jeffhao5d1ac922011-09-29 17:41:15 -0700685if [ "$usage" = "yes" ]; then
686 prog=`basename $prog`
687 (
688 echo "usage:"
689 echo " $prog --help Print this message."
690 echo " $prog [options] [test-name] Run test normally."
691 echo " $prog --dev [options] [test-name] Development mode" \
692 "(dumps to stdout)."
693 echo " $prog --update [options] [test-name] Update mode" \
694 "(replaces expected.txt)."
695 echo ' Omitting the test name or specifying "-" will use the' \
696 "current directory."
697 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000698 echo " -O Run non-debug rather than debug build (off by default)."
699 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000700 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000701 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800702 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700703 echo " --debug Wait for the default debugger to attach."
704 echo " --debug-agent <agent-path>"
705 echo " Wait for the given debugger agent to attach. Currently"
706 echo " only supported on host."
707 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
708 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700709 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000710 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000711 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700712 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000713 echo " --build-only Build test files only (off by default)."
Alan Leung0afa07a2017-10-03 16:56:30 -0700714 echo " --build-with-d8 Build test files with javac and d8 (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200715 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
716 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000717 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800718 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000719 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000720 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700721 echo " --verify-soft-fail Force soft fail verification (off by default)."
722 echo " Verification is enabled if neither --no-verify"
723 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000724 echo " --no-optimize Turn off optimization (on by default)."
725 echo " --no-precise Turn off precise GC (on by default)."
726 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700727 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000728 echo " other runtime options are ignored."
729 echo " --no-dex2oat Run as though dex2oat was failing."
730 echo " --no-patchoat Run as though patchoat was failing."
731 echo " --prebuild Run dex2oat on the files before starting test. (default)"
732 echo " --no-prebuild Do not run dex2oat on the files before starting"
733 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700734 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000735 echo " --relocate Force the use of relocating in the test, making"
736 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000737 echo " address before running."
738 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700739 echo " --image Run the test using a precompiled boot image. (default)"
740 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000741 echo " --host Use the host-mode virtual machine."
742 echo " --invoke-with Pass --invoke-with option to runtime."
743 echo " --dalvik Use Dalvik (off by default)."
744 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700745 echo " --use-java-home Use the JAVA_HOME environment variable"
746 echo " to find the java compiler and runtime"
747 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000748 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700749 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000750 echo " --64 Run the test in 64-bit mode"
751 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700752 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700753 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000754 echo " --gcstress Run with gc stress testing"
755 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700756 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700757 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700758 echo " --jvmti-redefine-stress"
759 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000760 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700761 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000762 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000763 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000764 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700765 echo " --instruction-set-features [string]"
766 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800767 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
768 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700769 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700770 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700771 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000772 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800773 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700774 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700775 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700776 exit 1
777fi
778
779cd "$test_dir"
780test_dir=`pwd`
781
782td_info="${test_dir}/${info}"
783td_expected="${test_dir}/${expected}"
784
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700785if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700786 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700787 exit 1
788fi
789
790if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700791 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700792 exit 1
793fi
794
795# copy the test to a temp dir and run it
796
Elliott Hughes510c8782011-10-06 10:57:34 -0700797echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700798
799rm -rf "$tmp_dir"
800cp -Rp "$test_dir" "$tmp_dir"
801cd "$tmp_dir"
802
803if [ '!' -r "$build" ]; then
804 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800805else
806 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700807fi
808
809if [ '!' -r "$run" ]; then
810 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800811else
812 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700813fi
814
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700815if [ '!' -r "$check_cmd" ]; then
816 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800817else
818 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700819fi
820
jeffhao5d1ac922011-09-29 17:41:15 -0700821chmod 755 "$build"
822chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700823chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700824
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700825export TEST_NAME=`basename ${test_dir}`
826
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000827# Tests named '<number>-checker-*' will also have their CFGs verified with
828# Checker when compiled with Optimizing on host.
829if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
830 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
831 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
832 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
833 run_checker="yes"
834
835 if [ "$target_mode" = "no" ]; then
836 cfg_output_dir="$tmp_dir"
837 checker_args="--arch=${host_arch_name^^}"
838 else
839 cfg_output_dir="$DEX_LOCATION"
840 checker_args="--arch=${target_arch_name^^}"
841 fi
842
843 if [ "$debuggable" = "yes" ]; then
844 checker_args="$checker_args --debuggable"
845 fi
846
847 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
848 -Xcompiler-option -j1"
849 fi
850 fi
851fi
852
Mathieu Chartier031768a2015-08-27 10:25:02 -0700853 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700854
Richard Uhler020c0f32017-03-14 16:23:17 +0000855# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
856# ART output to approximately 128MB. This should be more than sufficient
857# for any test while still catching cases of runaway output.
858# Set a hard limit to encourage ART developers to increase the ulimit here if
859# needed to support a test case rather than resetting the limit in the run
860# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000861if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000862 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700863fi
864
Igor Murashkin2de6e082018-02-28 15:25:23 -0800865# Tell the build script which mode (target, host, jvm) we are building for
866# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000867if [[ "$target_mode" == "yes" ]]; then
868 build_args="$build_args --target"
869else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800870 if [[ $runtime == "jvm" ]]; then
871 build_args="$build_args --jvm"
872 else
873 build_args="$build_args --host"
874 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000875fi
876
877if [[ "$dev_mode" == "yes" ]]; then
878 build_args="$build_args --dev"
879fi
880
jeffhao5d1ac922011-09-29 17:41:15 -0700881good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000882good_build="yes"
883good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700884export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700885if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000886 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700887 build_exit="$?"
888 echo "build exit status: $build_exit" 1>&2
889 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800890 echo "${test_dir}: running..." 1>&2
891 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700892 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000893
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800894 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000895 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100896 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000897 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100898 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100899 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000900 checker_exit="$?"
901 if [ "$checker_exit" = "0" ]; then
902 good="yes"
903 fi
Alex Light91de25f2015-10-28 17:00:06 -0700904 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000905 else
906 good="yes"
907 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800908 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000909 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700910 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700911elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000912 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700913 build_exit="$?"
914 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800915 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700916 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000917 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100918 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000919 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100920 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100921 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000922 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700923 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
924 good="yes"
925 else
Alex Light91de25f2015-10-28 17:00:06 -0700926 cat "$build_output" 1>&${real_stderr} 1>&2
927 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700928 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700929elif [ "$build_only" = "yes" ]; then
930 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000931 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700932 build_exit="$?"
933 if [ "$build_exit" '!=' '0' ]; then
934 cp "$build_output" "$output"
935 echo "build exit status: $build_exit" >>"$output"
936 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
937 if [ "$?" '!=' "0" ]; then
938 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700939 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700940 fi
941 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700942 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700943 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700944 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700945else
David Brazdil4846d132015-01-15 19:07:08 +0000946 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700947 build_exit="$?"
948 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800949 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700950 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000951 run_exit="$?"
952 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700953 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000954 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000955 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100956 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000957 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100958 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100959 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000960 checker_exit="$?"
961 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700962 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000963 good_run="no"
964 else
965 good_run="yes"
966 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000967 else
968 good_run="yes"
969 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700970 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000971 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700972 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700973 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
974 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700975 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700976 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700977 max_name_length=$(getconf NAME_MAX ${tmp_dir})
978 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
979 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700980 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700981 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700982 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700983 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000984 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
985 # output == expected
986 good="yes"
987 echo "${test_dir}: succeeded!" 1>&2
988 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700989 fi
990fi
991
jeffhao5d1ac922011-09-29 17:41:15 -0700992(
Alex Lightbfac14a2014-07-30 09:41:21 -0700993 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700994 echo "${test_dir}: FAILED!"
995 echo ' '
996 echo '#################### info'
997 cat "${td_info}" | sed 's/^/# /g'
998 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700999 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -07001000 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001001 if [ "$strace" = "yes" ]; then
1002 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001003 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001004 echo '####################'
1005 fi
Andreas Gampee79ca192017-07-31 10:30:16 -07001006 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
1007 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
1008 # tools used by the given ABI work for both x86 and x86-64.
1009 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
1010 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001011 echo ' '
1012 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001013
Alex Light91de25f2015-10-28 17:00:06 -07001014) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001015
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001016# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001017# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001018if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1019 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1020 if [ "$run_checker" == "yes" ]; then
1021 echo "${test_dir}: not bisecting, checker test." 1>&2
1022 else
1023 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001024 echo "${test_dir}: bisecting..." 1>&2
1025 cwd=`pwd`
1026 maybe_device_mode=""
1027 raw_cmd=""
1028 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001029 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001030 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1031 # to exec in order to preserve pid when calling dalvikvm. This is required
1032 # for bisection search to correctly retrieve logs from device.
1033 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001034 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001035 maybe_device_mode="--device"
1036 raw_cmd="$DEX_LOCATION/cmdline.sh"
1037 else
1038 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1039 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001040 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001041 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1042 $maybe_device_mode \
1043 --raw-cmd="$raw_cmd" \
1044 --check-script="$cwd/check" \
1045 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001046 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001047 --timeout=300
1048 fi
1049fi
1050
Alex Lightbfac14a2014-07-30 09:41:21 -07001051# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001052if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001053 cd "$oldwd"
1054 rm -rf "$tmp_dir"
1055 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001056 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001057 fi
1058 if [ "$good" = "yes" ]; then
1059 exit 0
1060 fi
1061fi
1062
1063
1064(
1065 if [ "$always_clean" = "yes" ]; then
1066 echo "${TEST_NAME} files deleted from host "
1067 if [ "$target_mode" == "yes" ]; then
1068 echo "and from target"
1069 fi
1070 else
1071 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1072 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001073 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001074 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001075 fi
1076
Alex Light91de25f2015-10-28 17:00:06 -07001077) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001078
Alex Light6a870fa2016-05-31 16:36:19 -07001079if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1080 exit 0
1081else
1082 exit 1
1083fi